package com.Neusoft.google.ui;

import android.annotation.SuppressLint;
import android.app.Fragment;
import android.content.Context;
import android.content.Intent;
import android.nfc.NdefRecord;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ListView;

import com.Neusoft.google.R;
import com.Neusoft.google.dialog.OpenNfc;
import com.Neusoft.google.dialog.SetKeyData;
import com.Neusoft.google.utils.Sharepreferenceutil;

@SuppressLint("ValidFragment")
public class Nfc extends Fragment {
	private static Context context;
	private View rootView;
	private Button scan;
	private Button uri;
	private Button mail;
	private Button people;
	private Button text;
	private Button sms;
	private Button tell;
	private Button app;
	private Button open;
	private Sharepreferenceutil nfcutil;
	public Nfc() {
        // Empty constructor required for fragment subclasses
    }
	public Nfc(Context c){
		context = c;
	}
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		// TODO Auto-generated method stub
        rootView = inflater.inflate(R.layout.nfc, container, false);
        init();
		return rootView;
	}
	public void init(){
		scan = (Button)rootView.findViewById(R.id.scan);
		uri = (Button)rootView.findViewById(R.id.uri);
		mail = (Button)rootView.findViewById(R.id.mail);
		people = (Button)rootView.findViewById(R.id.people);
		text = (Button)rootView.findViewById(R.id.text);
		sms = (Button)rootView.findViewById(R.id.sms);
		tell = (Button)rootView.findViewById(R.id.tell);
		app = (Button)rootView.findViewById(R.id.app);
		open = (Button)rootView.findViewById(R.id.open);
		nfcutil = new Sharepreferenceutil(context);
		scan.setOnClickListener(new scanlistener());
		mail.setOnClickListener(new writelistener());
		people.setOnClickListener(new writelistener());
		text.setOnClickListener(new writelistener());
		uri.setOnClickListener(new writelistener());
		tell.setOnClickListener(new writelistener());
		sms.setOnClickListener(new writelistener());
		app.setOnClickListener(new writelistener());
		open.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				new OpenNfc(context);
			}
		});
	}
	public class writelistener implements OnClickListener{
		@Override
		public void onClick(View v) {
			switch (v.getId()) {
			case R.id.uri:
				startActivity(new Intent(context,NfcWriteUriActivity.class));
				break;
			case R.id.mail:
				startActivity(new Intent(context,NfcWriteMailActivity.class));
				break;
			case R.id.people:
				startActivity(new Intent(context,NfcWriteContactActivity.class));
				break;
			case R.id.text:
				startActivity(new Intent(context,NfcWriteTextActivity.class));
				break;
			case R.id.sms:
				startActivity(new Intent(context,NfcWriteSmsActivity.class));
				break;
			case R.id.tell:
				startActivity(new Intent(context,NfcWriteTellActivity.class));
				break;
			case R.id.app:
				startActivity(new Intent(context,NfcWriteAppActivity.class));
				break;
			default:
				break;
			}
		}
	}
	public class scanlistener implements OnClickListener{
		@Override
		public void onClick(View v) {
			startActivity(new Intent(context,NfcScanActivity.class));
		}
	}
}