package com.Neusoft.google.ui;

import java.io.IOException;
import java.io.UnsupportedEncodingException;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.PendingIntent;
import android.content.Intent;
import android.content.res.AssetFileDescriptor;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.nfc.NdefMessage;
import android.nfc.NdefRecord;
import android.nfc.NfcAdapter;
import android.nfc.Tag;
import android.nfc.tech.Ndef;
import android.nfc.tech.NdefFormatable;
import android.os.Bundle;
import android.os.Vibrator;
import android.view.MenuItem;
import android.widget.TextView;
import android.widget.Toast;

import com.Neusoft.google.KeyData;
import com.Neusoft.google.R;
import com.Neusoft.google.dialog.OpenNfc;
import com.Neusoft.google.utils.Codeutil;
import com.Neusoft.google.utils.NewToast;
import com.Neusoft.google.utils.Sharepreferenceutil;

public class NfcScanActivity extends Activity{

	private static final float BEEP_VOLUME = 0.10f;
	private static final long VIBRATE_DURATION = 200L;
    NfcAdapter mAdapter;
    TextView promt;
    TextView rem;
    NdefMessage mNdefPushMessage;
    PendingIntent mPendingIntent;
    String[][] techListsArray;
    Sharepreferenceutil nfcutil;
    MediaPlayer right;
    MediaPlayer ohno;
    @Override
    public void onCreate(Bundle savedInstanceState) {
            super.onCreate(savedInstanceState);
            setContentView(R.layout.activity_nfcscan);
            getActionBar().setDisplayHomeAsUpEnabled(true);
            getActionBar().setHomeButtonEnabled(true);
            getActionBar().setBackgroundDrawable(this.getBaseContext().getResources().getDrawable(R.drawable.top_bg));
            getActionBar().setTitle("扫描标签的UID");
            getActionBar().setSubtitle("南海东软信息技术职业学院");
            nfcutil = new Sharepreferenceutil(this);
            promt = (TextView) findViewById(R.id.promt);
            rem = (TextView) findViewById(R.id.rem);
            rem.setText("比赛要求的UID : "+nfcutil.getKeyData(KeyData.NFCUID));
            // 获取默认的NFC控制器
            mAdapter = NfcAdapter.getDefaultAdapter(this);
            if (mAdapter == null) {
                    promt.setText("设备不支持NFC！");
                    finish();
                    return;
            }
            if (!mAdapter.isEnabled()) {
                    promt.setText("请在系统设置中先启用NFC功能！");
                    finish();
                    return;
            }
            mPendingIntent = PendingIntent.getActivity(this, 0, new Intent(this, getClass()).addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP), 0);
            initSound();
            initSound2();
    }


    @Override
    public void onNewIntent(Intent paramIntent) {
            setIntent(paramIntent);
            resolveIntent(paramIntent);
    }

    @Override
    protected void onResume() {
            super.onResume();
            if (this.mAdapter == null)
                    return;
            if (!this.mAdapter.isEnabled()) {
                    promt.setText("请在系统设置中先启用NFC功能！");
            }
            this.mAdapter.enableForegroundDispatch(this, this.mPendingIntent, null, null);
    }

    protected void resolveIntent(Intent intent) {
            // 得到是否检测到TAG触发
            if (NfcAdapter.ACTION_TECH_DISCOVERED.equals(intent.getAction()) || NfcAdapter.ACTION_TAG_DISCOVERED.equals(intent.getAction()) || NfcAdapter.ACTION_NDEF_DISCOVERED.equals(intent.getAction())) {
                    // 处理该intent
                    Tag tag = intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
                    // 获取id数组
                    byte[] bytesId = tag.getId();
                    promt.setText(Codeutil.bytesToHexString(bytesId));
                    if(nfcutil.getKeyData(KeyData.NFCUID).equals(Codeutil.bytesToHexString(bytesId))){
                    	new NewToast("正确~！", this, 1);
                    	autowrite(intent);
                    }
                    else{
                    	new NewToast("不是这个！", this, 0);
                    }
            }
    }
    private void initSound() {
    	right = new MediaPlayer();
    	AssetFileDescriptor rfile = getResources().openRawResourceFd(
				R.raw.right);
    	try {
    		right.setDataSource(rfile.getFileDescriptor(),
    				rfile.getStartOffset(), rfile.getLength());
    		rfile.close();
    		right.prepare();
		} catch (IOException e) {
			right = null;
		}
	}
    private void initSound2() {
    	ohno = new MediaPlayer();
    	AssetFileDescriptor nfile = getResources().openRawResourceFd(
				R.raw.ohno);
    	try {
    		ohno.setDataSource(nfile.getFileDescriptor(),
    				nfile.getStartOffset(), nfile.getLength());
    		nfile.close();
    		ohno.prepare();
		} catch (IOException e) {
			ohno = null;
		}
	}
    public void autowrite(Intent intent){
    	Tag tag = intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
		NdefMessage ndefMessage = null;
		try {
			ndefMessage = getNoteAsNdef();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (ndefMessage != null) {
			try {
				writeTag(getNoteAsNdef(), tag);
			} catch (UnsupportedEncodingException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		} else {
			showToast("请输入您要写入标签的内容");
		}
    }
    private NdefMessage getNoteAsNdef() throws UnsupportedEncodingException {
		String vcard = "BEGIN:VCARD" +"\n"+ "VERSION:2.1" +"\n" + "N:;" + "崔家铭" + "\n" +"ORG: "+"南海东软信息技术职业学院"+"\n"+ "END:VCARD";
		if (vcard.equals("")) {
			return null;
		} else {
			NdefRecord textRecord = createRecord(vcard);
			return new NdefMessage(new NdefRecord[] { textRecord });
		}

	}
 // 写入tag
 	boolean writeTag(NdefMessage message, Tag tag) {

 		int size = message.toByteArray().length;

 		try {
 			Ndef ndef = Ndef.get(tag);
 			if (ndef != null) {
 				ndef.connect();

 				if (!ndef.isWritable()) {
 					showToast("tag不允许写入");
 					return false;
 				}
 				if (ndef.getMaxSize() < size) {
 					showToast("文件大小超出容量");
 					return false;
 				}

 				ndef.writeNdefMessage(message);
            	new NewToast("写入数据成功", this, 1);
 				return true;
 			} else {
 				NdefFormatable format = NdefFormatable.get(tag);
 				if (format != null) {
 					try {
 						format.connect();
 						format.format(message);
 						showToast("格式化tag并且写入message");
 						return true;
 					} catch (IOException e) {
 						showToast("格式化tag失败.");
 						return false;
 					}
 				} else {
 					showToast("Tag不支持NDEF");
 					return false;
 				}
 			}
 		} catch (Exception e) {
 			showToast("写入数据失败");
 		}

 		return false;
 	}
	
	private NdefRecord createRecord(String text) throws UnsupportedEncodingException {

		// String nameVcard = "BEGIN:VCARD" +"\n"+ "VERSION:2.1" +"\n" + "N:;" + "\n" +"ORG: PlanAyala"+"\n"+ "TEL;HOME:6302421" +"\n"+ "END:VCARD";
	    String nameVcard = text;
		byte[] uriField = nameVcard.getBytes();
	    byte[] payload = new byte[uriField.length + 1];              //add 1 for the URI Prefix
	    //payload[0] = 0x01;                                      //prefixes http://www. to the URI
	    System.arraycopy(uriField, 0, payload, 1, uriField.length);  //appends URI to payload

	    NdefRecord nfcRecord = new NdefRecord(
	        NdefRecord.TNF_MIME_MEDIA, "text/vcard".getBytes(), new byte[0], payload);


	    return nfcRecord;
	}
	private void showToast(String text) {
		Toast.makeText(this, text, Toast.LENGTH_SHORT).show();
	}
    public boolean onOptionsItemSelected(MenuItem item)
    {
        // TODO Auto-generated method stub
        if(item.getItemId() == android.R.id.home)
        {
            finish();
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onPause() {
            super.onPause();
            if (this.mAdapter == null)
                    return;
            this.mAdapter.disableForegroundDispatch(this);
            this.mAdapter.disableForegroundNdefPush(this);
    }
}
