package com.Neusoft.google.ui;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.PendingIntent;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.res.AssetFileDescriptor;
import android.database.Cursor;
import android.net.Uri;
import android.nfc.NdefMessage;
import android.nfc.NdefRecord;
import android.nfc.NfcAdapter;
import android.nfc.Tag;
import android.nfc.tech.MifareClassic;
import android.nfc.tech.Ndef;
import android.nfc.tech.NdefFormatable;
import android.nfc.tech.NfcA;
import android.os.Bundle;
import android.provider.ContactsContract;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.Neusoft.google.R;
import com.Neusoft.google.utils.Codeutil;

/**
 * 写入标签
 * 
 * @warn：弹出dialog 允许写入
 * @author shenyang
 * 
 */
@SuppressLint("NewApi")
public class NfcWriteContactActivity extends Activity {
	private IntentFilter[] mWriteTagFilters;
	private NfcAdapter nfcAdapter;
	PendingIntent pendingIntent;
	String[][] mTechLists;
	Button writeBtn;
	Button writeBtn2;
	Button chose;
	String vcard;
	TextView text;
	EditText name;
	EditText org;
	boolean isWrite = false;
    public boolean onOptionsItemSelected(MenuItem item)
    {
        // TODO Auto-generated method stub
        if(item.getItemId() == android.R.id.home)
        {
            finish();
            return true;
        }
        return super.onOptionsItemSelected(item);
    }
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_nfcwritecontact);
        getActionBar().setDisplayHomeAsUpEnabled(true);
        getActionBar().setHomeButtonEnabled(true);
        getActionBar().setBackgroundDrawable(this.getBaseContext().getResources().getDrawable(R.drawable.top_bg));
        getActionBar().setTitle("写入联系人");
        getActionBar().setSubtitle("南海东软信息技术职业学院");
		name = (EditText)findViewById(R.id.name);
		org = (EditText)findViewById(R.id.org);
		text = (TextView)findViewById(R.id.textView1);
		writeBtn = (Button) findViewById(R.id.writeBtn);
		writeBtn2 = (Button) findViewById(R.id.writeBtn2);
		chose = (Button)findViewById(R.id.chose);
		chose.setOnClickListener(new OnClickListener() {
				
				@Override
				public void onClick(View v) {
					AlertDialog.Builder getfri = new AlertDialog.Builder(NfcWriteContactActivity.this);
					getfri.setTitle("选择联系人");
					final List<Map<String,String>> box = getfriends();
					getfri.setItems(listtoshuzu(box), new DialogInterface.OnClickListener() {
						
						@Override
						public void onClick(DialogInterface dialog, int which) {
							text.setText(Codeutil.qpDecoding(box.get(which).get("vcard").replace(";CHARSET=UTF-8;ENCODING=QUOTED-PRINTABLE", "")));
						}
					});
					getfri.setNegativeButton("取消", null);
					getfri.create().show();
				}
			});
		writeBtn.setOnClickListener(new WriteOnClick());
		writeBtn2.setOnClickListener(new WriteOnClick2());
		// 获取nfc适配器，判断设备是否支持NFC功能
		nfcAdapter = NfcAdapter.getDefaultAdapter(this);
		if (nfcAdapter == null) {
			showToast("设备不支持NFC！");
			finish();
			return;
		} else if (!nfcAdapter.isEnabled()) {
			showToast("请在系统设置中先启用NFC功能！");
			finish();
			return;
		}
		pendingIntent = PendingIntent.getActivity(this, 0, new Intent(this,
				getClass()).addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP), 0);
		// 写入标签权限
		IntentFilter writeFilter = new IntentFilter(
				NfcAdapter.ACTION_TECH_DISCOVERED);
		mWriteTagFilters = new IntentFilter[] { writeFilter };
		mTechLists = new String[][] {
				new String[] { MifareClassic.class.getName() },
				new String[] { NfcA.class.getName() } };// 允许扫描的标签类型
		name.setText("崔家铭");
		org.setText("南海东软信息技术职业学院");
	}

	class WriteOnClick2 implements OnClickListener {

		@Override
		public void onClick(View v) {
			String nameVcard = "BEGIN:VCARD" +"\n"+ "VERSION:2.1" +"\n" + "N:;" + name.getText().toString() + "\n" +"ORG: "+org.getText().toString()+"\n"+ "TEL;HOME;" +"\n"+ "END:VCARD";
			text.setText(nameVcard);
		}
	}
	/**
	 * 写入标签按钮点击事件监听
	 * 
	 * @author shenyang
	 * 
	 */
	class WriteOnClick implements OnClickListener {

		@Override
		public void onClick(View v) {
			// TODO Auto-generated method stub
			isWrite = true;
			AlertDialog.Builder builder = new AlertDialog.Builder(NfcWriteContactActivity.this)
					.setTitle("请将标签靠近！");
			builder.setNegativeButton("确定",
					new DialogInterface.OnClickListener() {

						@Override
						public void onClick(DialogInterface dialog, int which) {
							// TODO Auto-generated method stub
							dialog.dismiss();
							isWrite = false;
							NfcWriteContactActivity.this.finish();
						}
					});
			builder.setPositiveButton("取消",
					new DialogInterface.OnClickListener() {

						@Override
						public void onClick(DialogInterface dialog, int which) {
							// TODO Auto-generated method stub
							dialog.dismiss();
							isWrite = false;
						}
					});
			builder.create();
			builder.show();
		}
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		nfcAdapter.enableForegroundDispatch(this, pendingIntent,
				mWriteTagFilters, mTechLists);
	}

	// 写入模式时，才执行写入操作
	@Override
	protected void onNewIntent(Intent intent) {
		// TODO Auto-generated method stub
		super.onNewIntent(intent);
		if (isWrite == true
				&& NfcAdapter.ACTION_TECH_DISCOVERED.equals(intent.getAction())) {
			Tag tag = intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
			NdefMessage ndefMessage = null;
			try {
				ndefMessage = getNoteAsNdef();
			} catch (UnsupportedEncodingException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (ndefMessage != null) {
				try {
					writeTag(getNoteAsNdef(), tag);
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			} else {
				showToast("请输入您要写入标签的内容");
			}
		}
	}
	
	// 根据文本生成一个NdefRecord
	private NdefMessage getNoteAsNdef() throws UnsupportedEncodingException {
		vcard = text.getText().toString();
		if (vcard.equals("")) {
			return null;
		} else {
			NdefRecord textRecord = createRecord(text.getText().toString());
			return new NdefMessage(new NdefRecord[] { textRecord });
		}

	}
	
	private NdefRecord createRecord(String text) throws UnsupportedEncodingException {

		// String nameVcard = "BEGIN:VCARD" +"\n"+ "VERSION:2.1" +"\n" + "N:;" + "\n" +"ORG: PlanAyala"+"\n"+ "TEL;HOME:6302421" +"\n"+ "END:VCARD";
	    String nameVcard = text;
		byte[] uriField = nameVcard.getBytes();
	    byte[] payload = new byte[uriField.length + 1];              //add 1 for the URI Prefix
	    //payload[0] = 0x01;                                      //prefixes http://www. to the URI
	    System.arraycopy(uriField, 0, payload, 1, uriField.length);  //appends URI to payload

	    NdefRecord nfcRecord = new NdefRecord(
	        NdefRecord.TNF_MIME_MEDIA, "text/vcard".getBytes(), new byte[0], payload);


	    return nfcRecord;
	}
	private List<Map<String,String>> getfriends(){
		List<Map<String,String>> box = new ArrayList<Map<String,String>>();
		String[] projection = {ContactsContract.PhoneLookup.DISPLAY_NAME,
	            ContactsContract.CommonDataKinds.Phone.NUMBER};
		Cursor cursor = this.getContentResolver().query(ContactsContract.Contacts.CONTENT_URI, null, null, null, null);
		int index = cursor.getColumnIndex(ContactsContract.Contacts.LOOKUP_KEY); 
		cursor.moveToFirst();
		Map<String, String> map;
		String vars = null;
		do{
		     String lookupKey = cursor.getString(index);  
		     Uri uri = Uri.withAppendedPath(ContactsContract.Contacts.CONTENT_VCARD_URI, lookupKey);
		     AssetFileDescriptor fd = null;
		     try {
				fd = this.getContentResolver().openAssetFileDescriptor(uri, "r");
				FileInputStream fl = fd.createInputStream();
				InputStreamReader inputStreamReader = new InputStreamReader(fl);
				BufferedReader in = new BufferedReader(inputStreamReader);
				StringBuffer sBuffer = new StringBuffer();
				String con;
				while((con=in.readLine())!=null)
				sBuffer.append(con+"\n");
				vars = sBuffer.toString();
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			map = new HashMap<String, String>();
			map.put("name", cursor.getString(cursor.getColumnIndex(ContactsContract.PhoneLookup.DISPLAY_NAME)));
			map.put("vcard", vars);
			box.add(map);
		}
		while(cursor.moveToNext());
		cursor.close();
		return box;
	}
	private String[] listtoshuzu(List<Map<String,String>> box){
		String[] fribox = new String[box.size()];
		for(int i = 0;i<box.size();i++){
			fribox[i] = box.get(i).get("name");
		}
		return fribox;
	}
	// 写入tag
	boolean writeTag(NdefMessage message, Tag tag) {

		int size = message.toByteArray().length;

		try {
			Ndef ndef = Ndef.get(tag);
			if (ndef != null) {
				ndef.connect();

				if (!ndef.isWritable()) {
					showToast("tag不允许写入");
					return false;
				}
				if (ndef.getMaxSize() < size) {
					showToast("文件大小超出容量");
					return false;
				}

				ndef.writeNdefMessage(message);
				showToast("写入数据成功.");
				return true;
			} else {
				NdefFormatable format = NdefFormatable.get(tag);
				if (format != null) {
					try {
						format.connect();
						format.format(message);
						showToast("格式化tag并且写入message");
						return true;
					} catch (IOException e) {
						showToast("格式化tag失败.");
						return false;
					}
				} else {
					showToast("Tag不支持NDEF");
					return false;
				}
			}
		} catch (Exception e) {
			showToast("写入数据失败");
		}
		return false;
	}

	private void showToast(String text) {
		Toast.makeText(this, text, Toast.LENGTH_SHORT).show();
	}
}
