package com.Neusoft.google.ui;

import java.util.Map;

import android.annotation.SuppressLint;
import android.app.Fragment;
import android.content.Context;
import android.content.Intent;
import android.graphics.Paint.Join;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import com.Neusoft.google.KeyData;
import com.Neusoft.google.R;
import com.Neusoft.google.dialog.SetKeyData;
import com.Neusoft.google.utils.Codeutil;
import com.Neusoft.google.utils.Jsonutil;
import com.Neusoft.google.utils.Sharepreferenceutil;

@SuppressLint("ValidFragment")
public class QrCode extends Fragment {
	public static String RESULT = "result";
	private static Context context;
	private View rootView;
	private Button scan;
	private Button decode0;
	private Button decode1;
	private Button decode2;
	private TextView result;
	private TextView A;
	private TextView B;
	private TextView C;
	private TextView D;
	private EditText Akey;
	private EditText Bkey;
	private EditText Ckey;
	private EditText Dkey;
	private Sharepreferenceutil qrcode;
	private Map<String, String> map = null;
	public QrCode() {
        // Empty constructor required for fragment subclasses
    }
	public QrCode(Context c){
		context = c;
	}
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		// TODO Auto-generated method stub
        rootView = inflater.inflate(R.layout.qrcode, container, false);
        init();
		return rootView;
	}
	public void init(){
		scan = (Button)rootView.findViewById(R.id.scan);
		decode0 = (Button)rootView.findViewById(R.id.decode0);
		decode1 = (Button)rootView.findViewById(R.id.decode1);
		decode2 = (Button)rootView.findViewById(R.id.decode2);
		result = (TextView)rootView.findViewById(R.id.result);
		A = (TextView)rootView.findViewById(R.id.A);
		B = (TextView)rootView.findViewById(R.id.B);
		C = (TextView)rootView.findViewById(R.id.C);
		D = (TextView)rootView.findViewById(R.id.D);
		Akey = (EditText)rootView.findViewById(R.id.Akey);
		Bkey = (EditText)rootView.findViewById(R.id.Bkey);
		Ckey = (EditText)rootView.findViewById(R.id.Ckey);
		Dkey = (EditText)rootView.findViewById(R.id.Dkey);
		qrcode = new Sharepreferenceutil(context);
		initresult();
		scan.setOnClickListener(new scanlistner());
		decode0.setOnClickListener(new decodelistner());
		decode1.setOnClickListener(new decodelistner());
		decode2.setOnClickListener(new decodelistner());
		Akey.setText("WNAME");
		Bkey.setText("WPASS");
		Ckey.setText("CUID");
		Dkey.setText("IP");
	}
	public class scanlistner implements OnClickListener{
		@Override
		public void onClick(View v) {
			startActivityForResult(new Intent(context,CaptureActivity.class), 100);
		}
	}
	public class decodelistner implements OnClickListener{
		@Override
		public void onClick(View v) {
			switch (v.getId()) {
			case R.id.decode0:
				result.setText(Codeutil.hexStringToString(result.getText().toString()));
				break;
			case R.id.decode1:
				try {
					map = Jsonutil.getqrcodejson(result.getText().toString(), Akey.getText().toString(), Bkey.getText().toString(), Ckey.getText().toString(),  Dkey.getText().toString(),1);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				break;
			case R.id.decode2:
				try {
					map = Jsonutil.getqrcodejson(result.getText().toString(), Akey.getText().toString(), Bkey.getText().toString(), Ckey.getText().toString(), Dkey.getText().toString(), 2);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				break;
			}
			initresult();
			saveresult();
		}
	}
	public void initresult(){
		result.setText(qrcode.getqrcoderesult(RESULT));
		if(map!=null){
		A.setText(KeyData.WIFINAME+"结果："+map.get(Akey.getText().toString()));
		B.setText(KeyData.WIFIPASS+"结果："+map.get(Bkey.getText().toString()));
		C.setText(KeyData.NFCUID+"结果："+map.get(Ckey.getText().toString()));
		D.setText(KeyData.IPADDRESS+"结果："+map.get(Ckey.getText().toString()));
		}
	}
	public void saveresult(){
		qrcode.setKeyData(KeyData.WIFINAME, map.get(Akey.getText().toString()));
		qrcode.setKeyData(KeyData.WIFIPASS, map.get(Bkey.getText().toString()));
		qrcode.setKeyData(KeyData.NFCUID, map.get(Ckey.getText().toString()));
		qrcode.setKeyData(KeyData.IPADDRESS, map.get(Dkey.getText().toString()));
	}
	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		// TODO Auto-generated method stub
		if(resultCode==20){
			String json = data.getExtras().getString("result");
			qrcode.setqrcoderesult(json);
			initresult();
		}
		super.onActivityResult(requestCode, resultCode, data);
	}
}
