package com.Neusoft.google.ui;

import java.util.List;

import android.annotation.SuppressLint;
import android.app.Fragment;
import android.content.Context;
import android.net.wifi.WifiConfiguration;
import android.net.wifi.WifiConfiguration.AuthAlgorithm;
import android.net.wifi.WifiConfiguration.KeyMgmt;
import android.net.wifi.WifiConfiguration.Protocol;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioGroup;
import android.widget.RadioGroup.OnCheckedChangeListener;
import android.widget.Toast;

import com.Neusoft.google.KeyData;
import com.Neusoft.google.R;
import com.Neusoft.google.utils.Sharepreferenceutil;

@SuppressLint("ValidFragment")
public class Wifi extends Fragment {
	private static Context context;
	private View rootView;
	private EditText nameEditText, passwordEditText;
	private RadioGroup encryptRadioGroup;
	private Button connectBtn;
	private WifiManager mWifiManager;
	@SuppressLint("ValidFragment")
	private WifiCipherType type;
	private Sharepreferenceutil wifiutil;
	public Wifi() {
        // Empty constructor required for fragment subclasses
    }
	public Wifi(Context c){
		context = c;
	}
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		// TODO Auto-generated method stub
        rootView = inflater.inflate(R.layout.wifi, container, false);
		mWifiManager = (WifiManager) context
				.getSystemService(Context.WIFI_SERVICE);
		type = WifiCipherType.WIFICIPHER_WEP;
		if (mWifiManager.isWifiEnabled()) {
		} else {
			boolean isOpen = openWifi();
			if (isOpen) {
			} else {
			}
		}
		wifiutil = new Sharepreferenceutil(context);
        init();
		return rootView;
	}
	private void init() {
		nameEditText = (EditText) rootView.findViewById(R.id.name_edittext);
		passwordEditText = (EditText) rootView.findViewById(R.id.psd_edittext);
		encryptRadioGroup = (RadioGroup) rootView.findViewById(R.id.encrypt_radiogroup);
		connectBtn = (Button) rootView.findViewById(R.id.connect_wifi_btn);
		initresult();
		encryptRadioGroup
				.setOnCheckedChangeListener(new OnCheckedChangeListener() {
					@Override
					public void onCheckedChanged(RadioGroup group, int checkedId) {
						int radioBtnID = group.getCheckedRadioButtonId();
						if (radioBtnID == R.id.open_radiobtn) {
							type = WifiCipherType.WIFICIPHER_NOPASS;
						} else if (radioBtnID == R.id.wpa_radiobtn) {
							type = WifiCipherType.WIFICIPHER_PSK;
						} else if (radioBtnID == R.id.wep_radiobtn) {
							type = WifiCipherType.WIFICIPHER_WEP;
						}
					}
				});
		connectBtn.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				String name = nameEditText.getText().toString();
				String password = passwordEditText.getText().toString();
				if (name == null || name.equals("")) {
					Toast.makeText(context, "名称不能为空",
							Toast.LENGTH_SHORT).show();
					return;
				}
				boolean isConnect = Connect(name, password, type);
				if (isConnect) {
					Toast.makeText(context, "连接成功",
							Toast.LENGTH_SHORT).show();
				} else {
					Toast.makeText(context, "连接失败",
							Toast.LENGTH_SHORT).show();
				}
			}
		});
	}
	public void initresult(){
		nameEditText.setText(wifiutil.getKeyData(KeyData.WIFINAME));
		passwordEditText.setText(wifiutil.getKeyData(KeyData.WIFIPASS));
	}

	public boolean openWifi() {
		boolean isOpen = false;
		if (!mWifiManager.isWifiEnabled()) {
			isOpen = mWifiManager.setWifiEnabled(true);
		} else {
			return true;
		}
		return isOpen;
	}
	public boolean closeWifi() {
		boolean isClose = false;
		if (mWifiManager.isWifiEnabled()) {
			isClose = mWifiManager.setWifiEnabled(false);
		}
		return isClose;
	}

	public enum WifiCipherType {
		WIFICIPHER_PSK, WIFICIPHER_WEP, WIFICIPHER_NOPASS
	}

	public boolean Connect(String SSID, String Password, WifiCipherType Type) {
		if (!this.openWifi()) {
			return false;
		}
		while (mWifiManager.getWifiState() == WifiManager.WIFI_STATE_ENABLING) {
			try {
				Thread.currentThread();
				Thread.sleep(100);
			} catch (InterruptedException ie) {
			}
		}

		WifiConfiguration wifiConfig = this
				.CreateWifiInfo(SSID, Password, Type);
		if (wifiConfig == null) {
			return false;
		}
		WifiConfiguration tempConfig = this.IsExsits(SSID);

		if (tempConfig != null) {
			mWifiManager.removeNetwork(tempConfig.networkId);
		}
		int netID = mWifiManager.addNetwork(wifiConfig);
		Log.e("WIFIConnectActivity", "netID=" + netID);
		boolean bRet = mWifiManager.enableNetwork(netID, true);
		Log.e("WIFIConnectActivity", "bRet=" + bRet);
		if (bRet) {
			String ipAddress = "0.0.0.0";
			int i = 0;
			while (ipAddress.equals("0.0.0.0")) {
				WifiInfo info = mWifiManager.getConnectionInfo();
				int ip = info.getIpAddress();
				Log.e("WIFIConnectActivity", "int ip=" + ip);
				if (ip != 0) {
					ipAddress = ((ip & 0xff) + "." + (ip >> 8 & 0xff) + "."
							+ (ip >> 16 & 0xff) + "." + (ip >> 24 & 0xff));
				}
				Log.e("WIFIConnectActivity", ipAddress + "===========");
				i++;
				Log.e("WIFIConnectActivity", "i=" + i);
				try {
					Thread.sleep(500);
					if (i == 10) {
						break;
					}
				} catch (InterruptedException e) {
					Log.e("WIFIConnectActivity", "InterruptedException", e);
				}
			}
			if (i != 10) {
				return true;
			}
		}
		return false;
	}

	@SuppressLint({ "ParserError", "ParserError", "ParserError", "ParserError" })
	private WifiConfiguration IsExsits(String SSID) {
		List<WifiConfiguration> existingConfigs = mWifiManager
				.getConfiguredNetworks();
		for (WifiConfiguration existingConfig : existingConfigs) {
			// mWifiManager.removeNetwork(existingConfig.networkId);
			mWifiManager.disableNetwork(existingConfig.networkId);
			Log.e("WIFIConnectActivity", "�Ͽ���ǰ���ӵ����磡");
			if (existingConfig.SSID.equals("\"" + SSID + "\"")) {
				return existingConfig;
			}
		}
		return null;
	}

	private WifiConfiguration CreateWifiInfo(String SSID, String Password,
			WifiCipherType Type) {
		WifiConfiguration config = new WifiConfiguration();
		config.hiddenSSID = true;
		config.SSID = "\"" + SSID + "\"";
		if (Type == WifiCipherType.WIFICIPHER_NOPASS) {
			config.allowedKeyManagement.set(KeyMgmt.NONE);
		} else if (Type == WifiCipherType.WIFICIPHER_WEP) {
			config.allowedKeyManagement.set(KeyMgmt.NONE);
			config.allowedAuthAlgorithms.set(AuthAlgorithm.OPEN);
			config.allowedAuthAlgorithms.set(AuthAlgorithm.SHARED);
			int length = Password.length();
			if ((length == 10 || length == 26 || length == 58)
					&& Password.matches("[0-9A-Fa-f]*")) {
				config.wepKeys[0] = Password;
			} else {
				config.wepKeys[0] = '"' + Password + '"';
			}
		} else if (Type == WifiCipherType.WIFICIPHER_PSK) {
			config.allowedKeyManagement.set(KeyMgmt.WPA_PSK);
			if (Password.matches("[0-9A-Fa-f]{64}")) {
				config.preSharedKey = Password;
			} else {
				config.preSharedKey = '"' + Password + '"';
			}
		} else {
			return null;
		}
		config.priority = 2;
		config.allowedProtocols.set(Protocol.WPA);
		config.allowedProtocols.set(Protocol.RSN);
		return config;
	}
}
