package com.Neusoft.google.utils;

import java.io.DataOutputStream;
import java.io.IOException;
import java.net.ConnectException;
import java.net.Socket;
import java.net.SocketAddress;
import java.net.UnknownHostException;

import com.Neusoft.google.ui.Control;

import android.content.Context;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.widget.Toast;

public class ControlThread extends Thread implements Runnable {
	String SERVER_ADDRESS;
	int SERVER_POINT;
	DataOutputStream out;
	Socket s;
	Handler hd;

	public ControlThread(Handler hd,String ip, int port) {
		this.SERVER_ADDRESS = ip;
		this.SERVER_POINT = port;
		this.hd = hd;
	}

	public void run() {
		Message msg = hd.obtainMessage();
		System.out.println("正在连接服务器...");
		try {
			s = new Socket(SERVER_ADDRESS, SERVER_POINT);
			Log.i("", s.isConnected()+"");
			if(s.isConnected()){
				msg.what = 2;
				hd.sendMessage(msg);
			}
			out = new DataOutputStream(s.getOutputStream());
		}catch (ConnectException e) {
			msg.what = 3;
			hd.sendMessage(msg);
			e.printStackTrace();
		} 
		catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void send(String msg) {
		try {
			out.writeBytes(msg);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public void close() {
		try {
			s.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public Socket getSocket(){
		return s;
	}
}
