package com.Neusoft.google.utils;

import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import android.graphics.BitmapFactory;
import android.os.Handler;
import android.os.Message;

import com.Neusoft.google.ui.Control;

public class ImageServer extends Thread implements Runnable {
	private static int SERVER_POINT = 9000;
	private static ImageServer myserver;
	static ExecutorService serviceExecutors;
	static Handler hd;

	public ImageServer() {
	}

	public ImageServer(Handler hd) {
		this.hd = hd;
	}

	public void run() {
		serviceExecutors = Executors.newFixedThreadPool(10);
		myserver = new ImageServer();
		ServerSocket tcpSocket = null;
		try {

			tcpSocket = new ServerSocket(SERVER_POINT);
			System.out.println("开始监听..." + SERVER_POINT);
			while (true) {
				Socket scoket = tcpSocket.accept();
				Thread clientThread = myserver.new SingleClientThread(scoket,Control.saveway);
				serviceExecutors.execute(clientThread);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			try {
				tcpSocket.close();
				System.out.println("停止监听..." + SERVER_POINT);
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}

	}

	class SingleClientThread extends Thread {
		Socket scoketClient;
		int way;

		SingleClientThread(Socket client,int way) {
			this.scoketClient = client;
			this.way = way;
		}

		public void run() {
			try {
				Message msg = hd.obtainMessage();
				System.out.println("新连接..." + scoketClient.toString());
				DataInputStream is = new DataInputStream(
						scoketClient.getInputStream());
				System.out.println("ds..." + is);
				byte[] s = null;
				try {
					s = getData(is);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				System.out.println("byte..." + s.length);
				System.out.println("byte..." + s[0]);
				try {
					Control.bmpbyte = convertRgb2Bmp(s, formatBMPHeader());
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				msg.what = way;
				hd.sendMessage(msg);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	private byte[] getData(DataInputStream inputStream) {
		byte[] inputByte = new byte[1024];
		int length = -1;
		int count = 0;
		ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
		try {
			while ((length = inputStream.read(inputByte)) != -1) {
				outputStream.write(inputByte, 0, length);
				System.out.println("length..." + length);
				System.out.println("count..." + count);
				count += length;
				if (count == 320 * 240 * 2) {
					System.out.println("b..." + count);
					break;
				}
			}
			byte[] data = outputStream.toByteArray();
			System.out.println("data..." + data);
			inputStream.close();
			outputStream.flush();
			outputStream.close();
			return data;
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}

	public static byte[] convertRgb2Bmp(byte[] rgbBuf, byte[] header)
			throws Exception {
		ByteArrayOutputStream bos = new ByteArrayOutputStream();
		try {
			bos.write(header);
			int tmpData;
			int nextData;
			int sum;
			byte[] tmp;
			byte[] data = new byte[153600];
			for (int i = 0; i < 153600; i += 2) {
				tmpData = (int) (rgbBuf[i + 1] & 0xff) << 8;
				nextData = (int) (rgbBuf[i] & 0xff);
				sum = tmpData + nextData;
				sum = (sum & 0xffc0) >> 1 | ((char) (sum & 0x001f));
				tmp = intToWord(sum);
				data[i] = tmp[0];
				data[i + 1] = tmp[1];
			}
			bos.write(data);
			bos.flush();
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
			bos.close();
		}
		return bos.toByteArray();
	}

	public static byte[] formatBMPHeader() throws Exception {
		ByteArrayOutputStream bos = new ByteArrayOutputStream();
		try {
			bos.write(new byte[] { 'B', 'M' });
			// bos.write(intToDWord(width * height * 2 + 0x36));
			bos.write(intToDWord(320 * 240 * 2 + 0x36));
			bos.write(intToDWord(0));
			bos.write(intToDWord(0x36));
			bos.write(intToDWord(0x28));
			// bos.write(intToDWord(width));
			// bos.write(intToDWord(height));
			bos.write(intToDWord(320));
			bos.write(intToDWord(240));
			bos.write(intToWord(1));
			bos.write(intToWord(16));
			bos.write(intToDWord(0));
			bos.write(intToDWord(0));
			bos.write(intToDWord(0));
			bos.write(intToDWord(0));
			bos.write(intToDWord(0));
			bos.write(intToDWord(0));
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
			bos.close();
		}
		return bos.toByteArray();
	}

	private static byte[] intToWord(int parValue) {

		byte retValue[] = new byte[2];

		retValue[0] = (byte) (parValue & 0x00FF);
		retValue[1] = (byte) ((parValue >> 8) & 0x00FF);

		return (retValue);

	}

	private static byte[] intToDWord(int parValue) {

		byte retValue[] = new byte[4];

		retValue[0] = (byte) (parValue & 0x00FF);
		retValue[1] = (byte) ((parValue >> 8) & 0x000000FF);
		retValue[2] = (byte) ((parValue >> 16) & 0x000000FF);
		retValue[3] = (byte) ((parValue >> 24) & 0x000000FF);

		return (retValue);

	}

}
